Index: /trunk/src/world_entities/weapons/ground_turret.h
===================================================================
--- /trunk/src/world_entities/weapons/ground_turret.h	(revision 5750)
+++ /trunk/src/world_entities/weapons/ground_turret.h	(revision 5750)
@@ -0,0 +1,36 @@
+/*!
+ * @file ground_turret.h
+ * @brief description
+*/
+
+#ifndef _GROUND_TURRET_H
+#define _GROUND_TURRET_H
+
+#include "npcs/npc.h"
+
+class Weapon;
+
+//! A Class to ...
+class GroundTurret : public NPC
+{
+
+ public:
+  GroundTurret(const TiXmlElement* root = NULL);
+  virtual ~GroundTurret();
+
+  void loadParams(const TiXmlElement* root);
+  void init();
+
+  virtual void postSpawn ();
+  virtual void leftWorld ();
+
+
+  virtual void draw() const;
+  virtual void tick(float time);
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
+
+ private:
+   Weapon *left, *right;
+};
+
+#endif /* _GROUND_TURRET_H */
Index: /trunk/src/world_entities/weapons/laser.cc
===================================================================
--- /trunk/src/world_entities/weapons/laser.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/laser.cc	(revision 5750)
@@ -84,5 +84,5 @@
     Laser::explosionParticles->setName("LaserExplosionParticles");
     Laser::explosionParticles->setLifeSpan(.5, .3);
-    Laser::explosionParticles->setRadius(0.0, 3.0);
+    Laser::explosionParticles->setRadius(0.0, 10.0);
     Laser::explosionParticles->setRadius(.5, 6.0);
     Laser::explosionParticles->setRadius(1.0, 3.0);
Index: /trunk/src/world_entities/weapons/test_gun.cc
===================================================================
--- /trunk/src/world_entities/weapons/test_gun.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/test_gun.cc	(revision 5750)
@@ -41,5 +41,5 @@
 using namespace std;
 
-CREATE_FACTORY(TestGun);
+CREATE_FACTORY(TestGun, CL_TEST_GUN);
 
 /**
@@ -48,6 +48,6 @@
    creates a new weapon
 */
-TestGun::TestGun (WeaponManager* weaponManager, int leftRight)
-  : Weapon(weaponManager)
+TestGun::TestGun ( int leftRight)
+  : Weapon()
 {
   this->init();
Index: /trunk/src/world_entities/weapons/test_gun.h
===================================================================
--- /trunk/src/world_entities/weapons/test_gun.h	(revision 5749)
+++ /trunk/src/world_entities/weapons/test_gun.h	(revision 5750)
@@ -38,5 +38,5 @@
   {
   public:
-    TestGun (WeaponManager* weaponManager, int leftRight);
+    TestGun (int leftRight);
     TestGun (const TiXmlElement* root);
     virtual ~TestGun ();
Index: /trunk/src/world_entities/weapons/turret.cc
===================================================================
--- /trunk/src/world_entities/weapons/turret.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/turret.cc	(revision 5750)
@@ -30,16 +30,15 @@
 #include "factory.h"
 
-CREATE_FACTORY(Turret);
+CREATE_FACTORY(Turret, CL_TURRET);
 
 using namespace std;
 
-
 /**
  *  standard constructor
-
-   creates a new weapon
-*/
-Turret::Turret (WeaponManager* weaponManager)
-  : Weapon(weaponManager)
+ *
+ * creates a new Turret
+ */
+Turret::Turret ()
+  : Weapon()
 {
   this->init();
@@ -53,5 +52,7 @@
 }
 
-
+/**
+ * creates a new Turret from a TiXmlElement
+ */
 Turret::Turret(const TiXmlElement* root)
 {
@@ -117,5 +118,5 @@
 {
   Quaternion quat;
-  Vector direction = this->getWeaponManager()->getFixedTarget()->getAbsCoor() - this->getAbsCoor();
+  Vector direction = this->getAbsCoor();/*this->getWeaponManager()->getFixedTarget()->getAbsCoor() - this->getAbsCoor();*/
 
   direction.normalize();
@@ -135,13 +136,6 @@
     return;
 
-  PNode* target = this->getWeaponManager()->getFixedTarget();
-
-  if (target != NULL)
-  {
     pj->setVelocity(this->getVelocity()+(this->getAbsDir().apply(Vector(1,0,0))*100.0 + VECTOR_RAND(13)
             /*target->getAbsCoor() - this->getAbsCoor()*/)*.5);//this->getVelocity());
-  }
-  else
-    pj->setVelocity(target->getVelocity());
 
   pj->setParent(NullParent::getInstance());
@@ -159,6 +153,4 @@
 void Turret::draw () const
 {
-  this->getWeaponManager()->getFixedTarget()->debugDraw(10);
-
   /* draw gun body */
   glMatrixMode(GL_MODELVIEW);
Index: /trunk/src/world_entities/weapons/turret.h
===================================================================
--- /trunk/src/world_entities/weapons/turret.h	(revision 5749)
+++ /trunk/src/world_entities/weapons/turret.h	(revision 5750)
@@ -12,5 +12,5 @@
   {
   public:
-    Turret (WeaponManager* weaponManager);
+    Turret ();
     Turret(const TiXmlElement* root);
     virtual ~Turret ();
Index: /trunk/src/world_entities/weapons/weapon.cc
===================================================================
--- /trunk/src/world_entities/weapons/weapon.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/weapon.cc	(revision 5750)
@@ -41,8 +41,7 @@
  * creates a new weapon
 */
-Weapon::Weapon (WeaponManager* weaponManager)
+Weapon::Weapon ()
 {
   this->init();
-  this->setWeaponManager(weaponManager);
 }
 
@@ -97,6 +96,4 @@
   this->energyMax = 10.0;                          //< How much energy can be carried
   this->capability = WTYPE_ALL;                    //< The Weapon has all capabilities @see W_Capability.
-
-  this->setWeaponManager(NULL);                    //< By default the Weapon is free, and unhandled by a WeaponManager (this is good for small enemies).
 }
 
Index: /trunk/src/world_entities/weapons/weapon.h
===================================================================
--- /trunk/src/world_entities/weapons/weapon.h	(revision 5749)
+++ /trunk/src/world_entities/weapons/weapon.h	(revision 5750)
@@ -81,5 +81,5 @@
   public:
     // INITIALISATION //
-    Weapon (WeaponManager* weaponManager = NULL);
+    Weapon ();
     virtual ~Weapon ();
 
@@ -93,13 +93,8 @@
     ///////////////////
 
-    /** @param weaponManager sets the WeaponManager for this Weapon (NULL if free)) */
-    inline void setWeaponManager(WeaponManager* weaponManager) { this->weaponManager = weaponManager; };
-    /** @returns the WeaponManager of this Weapon (or NULL if it is free) */
-    inline WeaponManager* getWeaponManager() const { return this->weaponManager; };
-
     /** @returns true if the Weapon is Active  (this is used to check if the weapon must be drawn)*/
-    inline bool isActive() const { return (this->currentState == WS_INACTIVE)?false:true; };
+    inline bool isActive() const { return (this->currentState == WS_INACTIVE)? false : true; };
     /** @returns true if the weapon must be drawn */
-    inline bool isVisible() const { return (this->currentState != WS_INACTIVE || !this->hideInactive)?true:false; };
+    inline bool isVisible() const { return (this->currentState != WS_INACTIVE || !this->hideInactive) ? true : false; };
     /** @returns true if the Weapon is chargeable */
     inline bool isChargeable() const { return this->chargeable; };
@@ -120,4 +115,5 @@
 
 
+    // EMISSION
     void setEmissionPoint(const Vector& point);
     /** @see void setEmissionPoint(const Vector& point); */
@@ -126,4 +122,5 @@
     inline const Vector& getEmissionPoint() const { return this->emissionPoint.getAbsCoor(); };
 
+    // STATE CHANGES //
     /** @param state the State to time @param duration the duration of the State */
     inline void setStateDuration(const char* state, float duration) { setStateDuration(charToState(state), duration); };
@@ -131,7 +128,7 @@
     inline void setStateDuration(WeaponState state, float duration) { /*(state < WS_STATE_COUNT)?*/this->times[state] = duration; };
     /** @param state The state to query @returns the Time the queried State takes to complete */
-    inline float getStateDuration(WeaponState state) const { return (state < WS_STATE_COUNT)?this->times[state]:0.0; };
+    inline float getStateDuration(WeaponState state) const { return (state < WS_STATE_COUNT)? this->times[state] : 0.0; };
     /** @returns true if the time of the currentState is elapsed, false otherwise */
-    inline bool stateTimeElapsed() const { return (this->stateDuration > this->times[currentState])?true:false; };
+    inline bool stateTimeElapsed() const { return (this->stateDuration > this->times[currentState])? true : false; };
     /** @returns the current State of the Weapon */
     inline WeaponState getCurrentState() const { return this->currentState; };
@@ -149,4 +146,5 @@
     // FLOW
     void tickW(float dt); //!< this is a function that must be called by the weaponManager, or any other weaponHandler, all other functions are handled from within
+
     virtual void tick(float dt) {};
     virtual void draw() const;
@@ -194,5 +192,5 @@
     // it is all about energy
     float                energy;                           //!< The energy stored in the weapons secondary buffers (reserve)
-    float                energyLoaded;                     //!< The energy stored in the weapons primary buffers (firewithout reload)
+    float                energyLoaded;                     //!< The energy stored in the weapons primary buffers (fire without reload)
     float                energyMax;                        //!< The maximal energy that can be stored in the secondary buffers (reserveMax)
     float                energyLoadedMax;                  //!< The maximal energy that can be stored in the primary buffers
@@ -220,6 +218,4 @@
     ClassID              projectile;                      //!< the projectile used for this weapon (since they should be generated via macro and the FastFactory, only the ClassID must be known.)
     FastFactory*         projectileFactory;               //!< A factory, that produces and handles the projectiles.
-
-    WeaponManager*       weaponManager;                   //!< The weaponManager this weapon is connected to. if NULL it is assumed, that the weapon is freely connected to an entity without a binding WeaponManager.
   };
 
Index: /trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- /trunk/src/world_entities/weapons/weapon_manager.cc	(revision 5749)
+++ /trunk/src/world_entities/weapons/weapon_manager.cc	(revision 5750)
@@ -23,10 +23,11 @@
 #include "crosshair.h"
 
+#include "class_list.h"
 #include "load_param.h"
 #include "factory.h"
-#include "vector.h"
 #include "list.h"
 #include "t_animation.h"
 #include "null_parent.h"
+
 
 using namespace std;
@@ -109,4 +110,6 @@
   this->crossHairSizeAnim->addKeyFrame(100, .05, ANIM_LINEAR);
   this->crossHairSizeAnim->addKeyFrame(50, .01, ANIM_LINEAR);
+
+  this->targetIterator = NULL;
 }
 
@@ -334,4 +337,57 @@
     }
   }
+}
+
+
+/**
+ * Selects an Entity from the NPC-list, and returns the Target
+ */
+PNode* WeaponManager::getSomeTarget()
+{
+   if (this->targetIterator == NULL)
+   {
+     tList<BaseObject>* npcList = ClassList::getList(CL_NPC);
+     if (npcList != NULL)
+     {
+       this->targetIterator = npcList->getIterator();
+       this->targetIterator->firstElement();
+     }
+     else
+       return NULL;
+   }
+
+   PNode* retNode = dynamic_cast<PNode*>(targetIterator->nextElement());
+   if (retNode == NULL && this->targetIterator->getList()->getSize() > 0)
+     retNode =  dynamic_cast<PNode*>(targetIterator->firstElement());
+
+   return retNode;
+}
+
+
+/**
+ * Selects an Entity from the Entity-List, that is near of the carrier PNode.
+ * @param carrier: The PNode from which the distance should be measured
+ * @param distance: The Maximum Distance to Return.
+ */
+PNode* WeaponManager::getDistanceTarget(const PNode* carrier, float distance)
+{
+  tList<BaseObject>* npcList = ClassList::getList(CL_NPC);
+  if (npcList != NULL)
+  {
+    tIterator<BaseObject>* npcIT = npcList->getIterator();
+    PNode* tmpNPC = dynamic_cast<PNode*>(npcIT->firstElement());
+    while (tmpNPC != NULL)
+    {
+      if ((carrier->getAbsCoor() - tmpNPC->getAbsCoor()).len() < distance)
+      {
+        delete npcIT;
+        return tmpNPC;
+      }
+      tmpNPC = dynamic_cast<PNode*>(npcIT->nextElement());
+    }
+    delete npcIT;
+  }
+  return this->getFixedTarget();
+
 }
 
Index: /trunk/src/world_entities/weapons/weapon_manager.h
===================================================================
--- /trunk/src/world_entities/weapons/weapon_manager.h	(revision 5749)
+++ /trunk/src/world_entities/weapons/weapon_manager.h	(revision 5750)
@@ -17,4 +17,5 @@
 // FORWARD DECLARATION
 template <class T> class tAnimation;
+template <class T> class tIterator;
 
 
@@ -70,5 +71,6 @@
     void removeWeapon(Weapon* weapon, int configID = -1);
 
-
+    // FIXME ::
+//    bool hasFreeSlot(int configID, long capability = WTYPE_ALL) { return ( getNextFreeSlot(configID, capability ) != -1)? true : false; };
 
     void nextWeaponConfig();
@@ -77,6 +79,11 @@
 
     /** @returns a fixed target namely the Crosshair's 3D position */
-    inline PNode* getFixedTarget() { return this->crosshair; };
+    inline PNode* getFixedTarget() const { return this->crosshair; };
+    PNode* getSomeTarget();
+    PNode* getDistanceTarget(const PNode* carrier, float distance);
+
     void fire();
+    //! @TODO: implement this function (maybe also in Weapon itself)
+    void releaseFire();
 
     void tick(float dt);
@@ -85,5 +92,5 @@
     void debug() const;
 
-  private:
+ // private:
     int getNextFreeSlot(int configID, long capability = WTYPE_ALL);
 
@@ -102,3 +109,5 @@
     Crosshair*              crosshair;                                //!< an aim.
     tAnimation<Crosshair>*  crossHairSizeAnim;                        //!< An animation for the crosshair (scaling)
+
+    tIterator<BaseObject>*  targetIterator;                           //!< An iterator for traversion lists of enemies.
 };
